// coopservDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "coopserv.h"
#include "coopservDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCoopservDlg Dialogfeld

CCoopservDlg::CCoopservDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCoopservDlg::IDD, pParent)
{
	m_directory = "";
	//{{AFX_DATA_INIT(CCoopservDlg)
	m_mods_wert = -1;
	m_checkrestart_wert = FALSE;
	m_path = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON);
}

void CCoopservDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCoopservDlg)
	DDX_Control(pDX, IDC_CHECK_RESTART, m_checkrestart_control);
	DDX_Control(pDX, IDC_MODS, m_mods_control);
	DDX_Control(pDX, IDC_MAPS, m_maps);
	DDX_CBIndex(pDX, IDC_MODS, m_mods_wert);
	DDX_Check(pDX, IDC_CHECK_RESTART, m_checkrestart_wert);
	DDX_Text(pDX, IDC_PATH, m_path);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCoopservDlg, CDialog)
	//{{AFX_MSG_MAP(CCoopservDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_SUCHEXE, OnSuchexe)
	ON_BN_CLICKED(ID_START, OnLaunch)
	ON_CBN_SELENDOK(IDC_MODS, OnSelectMod)
	ON_BN_CLICKED(IDC_CHECK_RESTART, OnCheckRestart)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCoopservDlg Nachrichten-Handler

BOOL CCoopservDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	m_thread_while = false;
	m_thread_windowname = "";
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen
	

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CCoopservDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CCoopservDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCoopservDlg::OnSuchexe() 
{
	m_mods_control.ResetContent();
	UpdateData(TRUE);
	CFileDialog dlg(TRUE, NULL, "bf2_w32ded.exe", NULL, "BF2 Ded. Server|bf2_w32ded.exe||");
	dlg.m_ofn.Flags = dlg.m_ofn.Flags | OFN_HIDEREADONLY | OFN_EXPLORER | OFN_PATHMUSTEXIST;
	if (dlg.DoModal() == IDOK)
	{
		m_path = dlg.m_ofn.lpstrFile;
		UpdateData(FALSE);
		CString pfad = m_path;
		pfad.Delete(pfad.GetLength()-15,15);
		ModFind(pfad);
	}
}

void CCoopservDlg::OnLaunch() 
{
	HTREEITEM Auswahl = m_maps.GetSelectedItem();
    if (Auswahl == NULL) return;
	
	CString modname;
	int modauswahl = m_mods_control.GetCurSel();
	m_mods_control.GetLBText(modauswahl, modname);

	CString params = " +gameMode sp1 +ai 1 +modPath mods/" + modname + " +loadLevel " + m_maps.GetItemText(Auswahl);

	UpdateData(TRUE);

	if (GetFileAttributes(m_path) == 0xffffffff) AfxMessageBox("Choose a path, my young padawan");
	else {
		if (m_checkrestart_wert && m_thread_while == false)
		{
			m_thread_while = true;
			m_thread_windowname = "BF2 Memory Error";
			CWinThread *Thread = AfxBeginThread(windowkill, (LPVOID)this);
			}
			ShellExecute(NULL, "open", m_path, params , m_directory, SW_SHOWNORMAL);
		}
}


void CCoopservDlg::ModFind(CString pfad) 
{
	DWORD attr = GetFileAttributes(pfad);
	if (attr == 0xffffffff) return;
	
	m_mods_control.ResetContent();
	CFileFind finder;
	BOOL bWorking = finder.FindFile(pfad + "\\Mods\\*.*");
	while (bWorking)
	{	
		bWorking = finder.FindNextFile();
		if (finder.IsDirectory() && !finder.IsDots() && finder.GetFileName() != "bf2") m_mods_control.AddString(finder.GetFileName());
	}

	m_mods_control.SetCurSel(0);
	m_directory = pfad;
	OnSelectMod();
}

void CCoopservDlg::MapFind(CString modname) 
{
	m_maps.DeleteAllItems();
	DWORD attr = GetFileAttributes(m_directory + "\\mods\\" + modname + "\\Levels");
	if (attr == 0xffffffff) return;
	
	CFileFind finder;

	HTREEITEM Wurzel, map;
	Wurzel = m_maps.InsertItem("Maps");
	BOOL bWorking = finder.FindFile(m_directory + "\\mods\\" + modname + "\\Levels\\*.*");
	while (bWorking)
	{	
		bWorking = finder.FindNextFile();
		if (finder.IsDirectory() && !finder.IsDots()) map = m_maps.InsertItem(finder.GetFileName(), Wurzel);
	}
	m_maps.Expand(Wurzel, TVE_EXPAND);
}

void CCoopservDlg::OnSelectMod() 
{
	CString modname;
	m_mods_control.GetLBText(m_mods_control.GetCurSel(), modname);
	MapFind(modname);
}

UINT CCoopservDlg::windowkill(LPVOID klasse)
{
	//AfxMessageBox("THREADSTART");
	CCoopservDlg* m_klasse = (CCoopservDlg*)klasse;

	CWnd *fensterhandle;
	while (m_klasse->m_thread_while == true)
	{
		if (fensterhandle = CWnd::FindWindow(NULL,m_klasse->m_thread_windowname))
			{
			//AfxMessageBox("gefunden");
			fensterhandle->SendMessage(WM_CLOSE);
			m_klasse->m_thread_while = false;
			}
		Sleep(1000);
	}
	//AfxMessageBox("THREADENDE");
	m_klasse->OnLaunch();
	return 0;
}

void CCoopservDlg::OnCheckRestart() 
{
	//if (m_checkrestart_wert == FALSE) {AfxMessageBox("AUS");m_thread_while = false;}
}
